stages:
  - build
  - test
  - deploy


# Use our own image for building as a test
image:
  name: gitlab-registry.oit.duke.edu/duke_openshift_users/community-supported-resources/build-helper:alpine


.build:
  tags:
    - oit-shared
  stage: build
  variables:
    DOCKERFILE: Dockerfile
    # 720 hours == 30 days
    KANIKO_CACHE_TTL: "720h"
    KANIKO_EXTRA_ARGS: ""
    KANIKO_VERSION: v1.1.0
  image:
    # We have to use the debug version of the image in order to get a shell gitlab-ci
    # will be happy with
    name: gcr.io/kaniko-project/executor:debug-${KANIKO_VERSION}
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}"
      > /kaniko/.docker/config.json
    - /kaniko/executor
      --cache --cache-ttl=${KANIKO_CACHE_TTL}
      --registry-mirror image-mirror-prod-registry.cloud.duke.edu
      --context $CI_PROJECT_DIR --dockerfile ${CI_PROJECT_DIR}/${DOCKERFILE}
      --destination ${IMAGE_NAME}
      ${KANIKO_EXTRA_ARGS}


.deploy:
  tags:
    - oit-shared
  only:
    - main
  stage: deploy
  variables:
    # skip git checkout
    GIT_STRATEGY: none
    DEST_CREDS: ${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD}
    DEST_IMAGE: ""
    SOURCE_CREDS: ${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD}
    SOURCE_IMAGE: ""
  script:
    - skopeo copy --src-creds ${SOURCE_CREDS} --dest-creds ${DEST_CREDS}
      docker://${SOURCE_IMAGE} docker://${DEST_IMAGE}

build-ubuntu22:
  extends: .build
  variables:
    DOCKERFILE: Dockerfile-ubuntu22
    IMAGE_NAME: ${CI_REGISTRY}/${CI_PROJECT_PATH}:ci-${CI_PIPELINE_ID}-ubuntu22

build-alpine3.16:
  extends: .build
  variables:
    DOCKERFILE: Dockerfile-alpine3.16
    IMAGE_NAME: ${CI_REGISTRY}/${CI_PROJECT_PATH}:ci-${CI_PIPELINE_ID}-alpine3.16

deploy-ubuntu22:
  extends: .deploy
  needs:
    - build-ubuntu22
  variables:
    SOURCE_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:ci-${CI_PIPELINE_ID}-ubuntu22
    DEST_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:ubuntu22

deploy-alpine3.16:
  extends: .deploy
  needs:
    - build-alpine3.16
  variables:
    SOURCE_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:ci-${CI_PIPELINE_ID}-alpine3.16
    DEST_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:alpine3.16

deploy-alpine:
  extends: .deploy
  needs:
    - build-alpine3.16
  variables:
    SOURCE_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:ci-${CI_PIPELINE_ID}-alpine3.16
    DEST_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:alpine
